/*
 * medium.c
 *
 * Serial Hander
 *
 * Copyright (C) 2004-2008 Atmark Techno, Inc.	All Rights Reserved.
 *
 */
#include "xuartlite_l.h"
#include "memmap.h"

//int bin_to_ascii(unsigned char k)
//{
//    if ( k > 9 )
//        put_char (0x37 + k);
//    else
//        put_char (0x30 + k);
//    return 0;
//}
//
//int sendchar_bin_to_ascii(unsigned char j)
//{
//    long i ;
//
//    for ( i = 1; i >= 0 ; i--)
//        bin_to_ascii(((j) >> ( i << 2 )) & 0xf );
//
//    return 0;
//}
//
//
//int sendshort_bin_to_ascii(unsigned short j)
//{
//    long i ;
//
//    for ( i = 3; i >= 0 ; i--)
//        bin_to_ascii(((j) >> ( i << 2 )) & 0xf );
//    return 0;
//}
//
//int sendword_bin_to_ascii(unsigned long j)
//{
//    long i ;
//
//    for ( i = 7; i >= 0 ; i--)
//        bin_to_ascii(((j) >> ( i << 2 )) & 0xf );
//
//    return 0;
//}

int put_char(unsigned long data)
{
	while (XUartLite_IsTransmitFull(UART_BASEADDR));
	XUartLite_SendByte(UART_BASEADDR, (unsigned char)data);

	return 0;
}

int put_char_hex(unsigned long j)
{
	long i ;
	unsigned long k ;

	for (i = 7; i >= 0 ; i--) {
		k = ((j) >> ( i << 2 )) & 0xf;
		if (k > 9)
			put_char(0x37 + k);
		else
			put_char(0x30 + k);
	}
	put_char('\r');
	put_char('\n');

	return 0;
}

char get_char(void)
{
	while (XUartLite_IsReceiveEmpty(UART_BASEADDR));

	return XUartLite_RecvByte(UART_BASEADDR);
}

/*
 * get entire line, which is terminated with '\r'
 * returns 0 if just return key is hit.
 * otherwise this function blocks forever.
 */
int get_line(char *buffer, int maxchars)
{
	int line_size = 0;
	char test;
	while (maxchars) {
		*buffer = get_char();
		if (*buffer == '\r')
			break;
		buffer++;
		line_size++;
		maxchars--;
	}
	*buffer = '\0'; /* overwrite the last '\r', or last char in case of maxchar, with nul */

	return line_size;
}

void myprint(char * s)
{
	while (*s)
		put_char(*s++);
}
